Liferay.Loader.define("dynamic-data-mapping-form-field-type@5.0.83/components/Tooltip/Tooltip.soy", ['module', 'exports', 'require', 'frontend-js-metal-web$metal-component', 'frontend-js-metal-web$metal-soy'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = exports.templates = exports.Tooltip = void 0;

    var _metalComponent = _interopRequireDefault(require("frontend-js-metal-web$metal-component"));

    var _metalSoy = _interopRequireDefault(require("frontend-js-metal-web$metal-soy"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    var templates;
    exports.templates = templates;
    goog.loadModule(function (exports) {
      var soy = goog.require('soy');

      goog.require('soydata');

      // This file was automatically generated from Tooltip.soy.
      // Please don't edit this file by hand.

      /**
       * @fileoverview Templates in namespace Tooltip.
       * @public
       */

      goog.module('Tooltip.incrementaldom');

      goog.require('goog.soy.data.SanitizedContent');

      var incrementalDom = goog.require('incrementaldom');

      goog.require('soy.asserts');

      var soyIdom = goog.require('soy.idom');

      var $templateAlias1 = _metalSoy.default.getTemplate('FormPortal.incrementaldom', 'render');
      /**
       * @param {{
       *  icon: (!goog.soy.data.SanitizedContent|string),
       *  _handleTooltipHovered: (*|null|undefined),
       *  _handleTooltipLeaved: (*|null|undefined),
       *  _handleTooltipRendered: (*|null|undefined),
       *  position: (!goog.soy.data.SanitizedContent|null|string|undefined),
       *  showContent: (boolean|null|undefined),
       *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
       *  text: (!goog.soy.data.SanitizedContent|null|string|undefined)
       * }} opt_data
       * @param {Object<string, *>=} opt_ijData
       * @param {Object<string, *>=} opt_ijData_deprecated
       * @return {void}
       * @suppress {checkTypes}
       */

      function $render(opt_data, opt_ijData, opt_ijData_deprecated) {
        opt_ijData = opt_ijData_deprecated || opt_ijData;
        /** @type {!goog.soy.data.SanitizedContent|string} */

        var icon = soy.asserts.assertType(goog.isString(opt_data.icon) || opt_data.icon instanceof goog.soy.data.SanitizedContent, 'icon', opt_data.icon, '!goog.soy.data.SanitizedContent|string');
        /** @type {*|null|undefined} */

        var _handleTooltipHovered = opt_data._handleTooltipHovered;
        /** @type {*|null|undefined} */

        var _handleTooltipLeaved = opt_data._handleTooltipLeaved;
        /** @type {*|null|undefined} */

        var _handleTooltipRendered = opt_data._handleTooltipRendered;
        /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

        soy.asserts.assertType(opt_data.position == null || goog.isString(opt_data.position) || opt_data.position instanceof goog.soy.data.SanitizedContent, 'position', opt_data.position, '!goog.soy.data.SanitizedContent|null|string|undefined');

        /** @type {boolean|null|undefined} */

        var showContent = soy.asserts.assertType(opt_data.showContent == null || goog.isBoolean(opt_data.showContent) || opt_data.showContent === 1 || opt_data.showContent === 0, 'showContent', opt_data.showContent, 'boolean|null|undefined');
        /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

        var spritemap = soy.asserts.assertType(opt_data.spritemap == null || goog.isString(opt_data.spritemap) || opt_data.spritemap instanceof goog.soy.data.SanitizedContent, 'spritemap', opt_data.spritemap, '!goog.soy.data.SanitizedContent|null|string|undefined');
        /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

        soy.asserts.assertType(opt_data.text == null || goog.isString(opt_data.text) || opt_data.text instanceof goog.soy.data.SanitizedContent, 'text', opt_data.text, '!goog.soy.data.SanitizedContent|null|string|undefined');

        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'ddm-tooltip');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('data-onmouseleave', _handleTooltipLeaved);
        incrementalDom.attr('data-onmouseover', _handleTooltipHovered);
        incrementalDom.attr('ref', 'tooltipTarget');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('svg');
        incrementalDom.attr('aria-hidden', 'true');
        incrementalDom.attr('class', 'lexicon-icon lexicon-icon-' + icon);
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('use');
        incrementalDom.attr('xlink:href', spritemap + '#' + icon);
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('use');
        incrementalDom.elementClose('svg');
        incrementalDom.elementClose('div');

        var content__soy253 = function content__soy253() {
          $content(opt_data, null, opt_ijData);
        };

        if (showContent) {
          var param264 = function param264() {
            content__soy253();
          };

          $templateAlias1({
            contentRenderer: param264,
            ref: 'tooltipSource',
            portalElement: '#clay_dropdown_portal',
            events: {
              rendered: _handleTooltipRendered
            }
          }, null, opt_ijData);
        }

        incrementalDom.elementClose('div');
      }

      exports.render = $render;
      /**
       * @typedef {{
       *  icon: (!goog.soy.data.SanitizedContent|string),
       *  _handleTooltipHovered: (*|null|undefined),
       *  _handleTooltipLeaved: (*|null|undefined),
       *  _handleTooltipRendered: (*|null|undefined),
       *  position: (!goog.soy.data.SanitizedContent|null|string|undefined),
       *  showContent: (boolean|null|undefined),
       *  spritemap: (!goog.soy.data.SanitizedContent|null|string|undefined),
       *  text: (!goog.soy.data.SanitizedContent|null|string|undefined)
       * }}
       */

      $render.Params;

      if (goog.DEBUG) {
        $render.soyTemplateName = 'Tooltip.render';
      }
      /**
       * @param {{
       *  position: (!goog.soy.data.SanitizedContent|null|string|undefined),
       *  text: (!goog.soy.data.SanitizedContent|null|string|undefined)
       * }} opt_data
       * @param {Object<string, *>=} opt_ijData
       * @param {Object<string, *>=} opt_ijData_deprecated
       * @return {void}
       * @suppress {checkTypes}
       */

      function $content(opt_data, opt_ijData, opt_ijData_deprecated) {
        opt_ijData = opt_ijData_deprecated || opt_ijData;
        opt_data = opt_data || {};
        /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

        var position = soy.asserts.assertType(opt_data.position == null || goog.isString(opt_data.position) || opt_data.position instanceof goog.soy.data.SanitizedContent, 'position', opt_data.position, '!goog.soy.data.SanitizedContent|null|string|undefined');
        /** @type {!goog.soy.data.SanitizedContent|null|string|undefined} */

        var text = soy.asserts.assertType(opt_data.text == null || goog.isString(opt_data.text) || opt_data.text instanceof goog.soy.data.SanitizedContent, 'text', opt_data.text, '!goog.soy.data.SanitizedContent|null|string|undefined');
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'clay-tooltip-' + position + ' ddm-tooltip-container tooltip');
        incrementalDom.attr('role', 'tooltip');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'arrow');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementClose('div');
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'tooltip-inner');
        incrementalDom.elementOpenEnd();
        incrementalDom.elementOpenStart('div');
        incrementalDom.attr('class', 'ddm-tooltip-text');
        incrementalDom.elementOpenEnd();
        soyIdom.print(text);
        incrementalDom.elementClose('div');
        incrementalDom.elementClose('div');
        incrementalDom.elementClose('div');
      }

      exports.content = $content;
      /**
       * @typedef {{
       *  position: (!goog.soy.data.SanitizedContent|null|string|undefined),
       *  text: (!goog.soy.data.SanitizedContent|null|string|undefined)
       * }}
       */

      $content.Params;

      if (goog.DEBUG) {
        $content.soyTemplateName = 'Tooltip.content';
      }

      exports.render.params = ["icon", "_handleTooltipHovered", "_handleTooltipLeaved", "_handleTooltipRendered", "position", "showContent", "spritemap", "text"];
      exports.render.types = {
        "icon": "string",
        "_handleTooltipHovered": "any",
        "_handleTooltipLeaved": "any",
        "_handleTooltipRendered": "any",
        "position": "string",
        "showContent": "bool",
        "spritemap": "string",
        "text": "string"
      };
      exports.content.params = ["position", "text"];
      exports.content.types = {
        "position": "string",
        "text": "string"
      };
      exports.templates = templates = exports;
      return exports;
    });

    var Tooltip = /*#__PURE__*/function (_Component) {
      _inherits(Tooltip, _Component);

      function Tooltip() {
        _classCallCheck(this, Tooltip);

        return _possibleConstructorReturn(this, _getPrototypeOf(Tooltip).apply(this, arguments));
      }

      return Tooltip;
    }(_metalComponent.default);

    exports.Tooltip = Tooltip;

    _metalSoy.default.register(Tooltip, templates);

    var _default = templates;
    /* jshint ignore:end */

    exports.default = _default;
    //# sourceMappingURL=Tooltip.soy.js.map
  }
});
//# sourceMappingURL=Tooltip.soy.js.map